#include "linked_list.h"
#include "Phone.h"
#include <stdlib.h>

void add(node ** head, phone * data)
{
  if(*head == NULL)
  {
    *head = malloc(sizeof(node));
    (*head)->p = data;
    (*head)->next = NULL;
  }
  else
  {
    node * temp = *head;
    while(temp->next != NULL)
      temp = temp->next;

    temp->next = malloc(sizeof(node));
    temp->next->p = data;
    temp->next->next = NULL;
  }
}

int contains(node ** head, phone * p)
{
	if(*head != NULL)
	{
		node * temp = *head;

		while(temp != NULL)
		{
			if(temp->p == p)
				return 1;
			temp = temp->next;
		}
	}
	return 0;
}

void find_and_remove(node ** head, phone * p)
{
	if(*head != NULL)
	{
		node * prev = *head;
		node * temp = (*head)->next;

		if(prev->p == p)
		{
			*head = temp;
			prev->next = NULL;
			prev->p = NULL;
			free((void *) prev);
		}
		else
		{
			while(temp->p != p && temp->next != NULL)
			{
				prev = temp;
				temp = temp->next;
			}

			if(temp->p == p)
			{
				prev->next = temp->next;
				temp->next = NULL;
				temp->p = NULL;
				free((void *) temp);
			}
		}
	}
}

void remove_node(node ** head)
{
  node * prev;
  node * temp;
  if(*head != NULL)
  {
    prev = *head;
    temp = (*head)->next;

    if(temp == NULL)
    {
      prev->p = NULL;
      prev = NULL;
      free((void *) *head);
      *head = NULL;
    }
    else
    {
      prev = *head;
      temp = (*head)->next;
      while(temp->next != NULL)
      {
        prev = temp;
        temp = temp->next;
      }

      temp->p = NULL;
      free((void *) temp);
      temp = NULL;
      prev->next = NULL;
    }
  }
}

phone * get_last(node ** head)
{
  if(*head == NULL)
    return NULL;
  else
  {
    node * temp = *head;

    while(temp->next != NULL)
      temp = temp->next;

    return temp->p;
  }
}

int size(node ** head)
{
	if(*head==NULL)
		return 0;
	else
	{
		int count = 0;
		node * temp = *head;

		while(temp != NULL)
		{
			count++;
			temp = temp->next;
		}
		return count;
	}
}
